hdu 1011

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6857    Accepted Submission(s): 1860


Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.
 

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.
 

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.
 

Sample Input
  
  
5 10 50 10 40 10 40 20 65 30 70 30 1 2 1 3 2 4 2 5 1 1 20 7 -1 -1
 

Sample Output
  
  
50 7
 
 
 
 
 
 
 
 
题意:
带领m个士兵,存在n个房间;每个房间有两个参数:放置的bugs数以及存在头领的可能性。
每个士兵可以抵抗20个bugs,只有消灭房间中的所有bugs,才可以得到该房间的头领的可能性。
有指定的房间与房间之间的联通性,要到达下一个房间,必须先将当前房间的bugs全部消除;并且走过的房间就不再到达。
问有m个士兵的情况下,怎样使最后得到的头领的可能性最大,最大为多少?
 
 
初看这道题,觉得有点像01背包,又有点像分组背包。。。
但细细分析,发现因为涉及到了树,所以要用到搜索;
 
就我的理解而言,树状DP,与其他不同的也就是添加进了树的元素,每个元素的选择有了限制,就变成了父元素与其子元素的最优解。
这道题也是如此~
 
对于每个房间,除去它本身所需要的士兵,其他的士兵就可以提供给它的子房间进行选择,子房间将其最优的选择提供给父节点,父节点通过子房间的解得到最优解。
 
可以得到一个式子:
 
dp[i][j]=max(dp[i][j],dp[i][j-k]+dp[son(i)][k])
 
其中,j为总的士兵数m~第i个房间所需要的士兵数
dp[i][j]表示第i个房间以及其子节点花费j个士兵可以得到的最大可能值;
 
 
代码:
 
#include<iostream>
using namespace std;
int dp[105][105];
int a[105][105];
int value[105];
int p[105];
int v;
int n;
int visit[105];
int maxn(int a1,int b1){
    if(a1<b1)
       return b1;
    return a1;
}
int DFS(int now,int pre){
 //   visit[now]=1;
    int tem=(value[now]+19)/20;
    for(int k=tem;k<=v;k++){
            dp[now][k]=p[now];
            }
    for(int i=1;i<=n;i++){
   //         if(visit[i]==0){
            if((a[now][i]==1)&&i!=pre){
              //      cout<<i<<endl;
                    DFS(i,now);
                    for(int j=v;j>=tem;j--){
                            for(int k=1;k<=j-tem;k++){
                                    dp[now][j]=maxn(dp[now][j],dp[now][j-k]+dp[i][k]);
                                    }
                                    }
                                    }
                   //                 }
                                    }
    return 0;
}
int main(){
 //   int n;
    while(cin>>n>>v){
         if(n==-1&&v==-1)
              break;
         
         for(int i=1;i<=n;i++){
                 cin>>value[i]>>p[i];
                 }
      //   v=v*20;
//         memset(visit,0,sizeof(visit));
         memset(a,0,sizeof(a));
         for(int j=0;j<n-1;j++){
                 int temp1,temp2;
                 cin>>temp1>>temp2;
                 a[temp1][temp2]=1;
                 a[temp2][temp1]=1;
                 }
         if(v==0){
                  cout<<"0"<<endl;
                  continue;
                  }
         memset(dp,0,sizeof(dp));
         DFS(1,-1);
         cout<<dp[1][v]<<endl;
         }
    return 0;
}

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值